# Las siguientes 2 lineas son opcionales. Al tener un entorno de pruebas la configuración SSL está autofirmada.
import urllib3
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

import csv
import pandas as pd
from datetime import datetime
from mstrio.types import ObjectSubTypes, ObjectTypes
from mstrio.project_objects import Dossier
from mstrio.project_objects.dossier import list_dossiers_across_projects
from mstrio.object_management import Object

from mstrio.connection import Connection

mstr_usuario = "Administrator"
mstr_pass = "Micro123"
mstr_base_url = "https://desktop-5dqnoai:8443"
mstr_url_api  = mstr_base_url+"/MicroStrategyLibrary/api"
projecto_id    = "B7CA92F04B9FAE8D941C3E9B7E0CD754"

# Si se desa obtener de todos los proyectos quitar el parametro project_id=project_id
# ssl_verify=False es un parametro opcional.

print("\nEjecutando... por favor, espere.\n")

conn = Connection(mstr_url_api, mstr_usuario, mstr_pass, project_id=projecto_id, ssl_verify=False)

def search_ancestors(ancestors):
    path=''
    if ancestors: # necessary if you set get_ancestors parameter to false
        for i in range(len(ancestors)):
            path= path+' > '+(ancestors[i]['name'])
    else:
        path="___NO PATH"
    return path[3:]

def get_datasets(connection, project_ID, dossier_ID):
    res = connection.get(url=f"{connection.base_url}/api/v2/dossiers/{dossier_ID}/definition",
                                headers={'X-MSTR-ProjectID': project_ID})
    return res

def get_object(connection, project_ID, object_ID):
    res = connection.get(url=f"{connection.base_url}/api/objects/{object_ID}?type=3",
                                headers={'X-MSTR-ProjectID': project_ID})
    return res

ldap=list_dossiers_across_projects(connection=conn)
print(f"Nº de dossiers: {len(ldap)}")

count_dos=0  # this counter will give you hints how long the whole process will take
dt1=datetime.now()
dossiers_list,datasets_list=[],[]

for a in ldap[:]:        
    datasets_json=get_datasets(conn, a._project_id, a.id).json()
    datasets_local=[["missing","missing"]]
    
    if djd:=datasets_json.get('datasets'): # walrus operator; works for Python 3.8 or higher
        datasets_local=[]
        for d in djd:
            datasets_local.append([d['name'], d['id']]) #this is just for this dossier
            datasets_list.append((d['name'], d['id'], a._project_id)) #this gathers all datasets
    for dt in datasets_local:
        dossiers_list.append([a._project_id, a.id, a.name, search_ancestors(a._ancestors),
                              a._date_created.strftime("%Y-%m-%d %H:%M:%S"),
                              a._date_modified.strftime("%Y-%m-%d %H:%M:%S"),
                              dt[0], dt[1]])        
    
    count_dos+=1
    if (count_dos % 50) == 0 or count_dos == (len(ldap)):
        eta = (len(ldap[:])/count_dos)*(datetime.now()-dt1)
        print(count_dos, "dossiers procesados: ", eta)

print(f"Nº datasets: {len(dossiers_list)} (algunos estan vacios, otros se usan varias veces)")
datasets_list=list(set(datasets_list))
print(f"Datasets unicos: {len(datasets_list)}")

# Exportar dossiers a CSV
headers_dossiers=["ID Proyecto", "ID Dossier","Nombre Dossier", "Ruta Dossier", "Fecha creación", "Fecha modificación", 
                  "Nombre Dataset", "Id Dataset"]
df = pd.DataFrame(dossiers_list, columns = headers_dossiers)
df.to_csv(f"C:\\tmp\\lista_de_dossiers.csv", index=False, encoding='utf-8', sep=",", 
          quoting=csv.QUOTE_ALL, header=True)
          
print("\nFin de la exportación de dossiers.\n")

count_dos=0 
dt1=datetime.now()
datasets_list_new=[]

for b in datasets_list[:]:        
    dj=get_object(conn, b[2], b[1]).json()
    datasets_list_new.append([b[2], dj["id"], dj["name"], dj["type"], dj["subtype"], 
                              dj["dateCreated"], dj["dateModified"], search_ancestors(dj["ancestors"])])
    
    count_dos+=1
    if (count_dos % 50) == 0 or count_dos == (len(datasets_list)):
        eta = (len(datasets_list[:])/count_dos)*(datetime.now()-dt1)
        print(count_dos, "datasets procesados: ", eta)

# Exportar datasets a CSV
headers_datasets=["ID Proyecto","Id Dataset", "Nombre Dataset", "Tipo Dataset","Subtipo Dataset",
                  "Fecha creación","Fecha modificación","Ruta Dataset"]
df = pd.DataFrame(datasets_list_new, columns = headers_datasets)
df.to_csv(f"C:\\tmp\\lista_de_datasets.csv", index=False, encoding='utf-8', sep=",", 
          quoting=csv.QUOTE_ALL, header=True)

print("\nFin de la exportación datasets.\n")